<?php

//define ("NODE_TYPE_START",0);
define ("NODE_TYPE_TAGELEMENT",1);       //полностью сформированный открывающий HTML-тег
define ("NODE_TYPE_TAGBEGINELEMENT",10); //только открывающая '<'
define ("NODE_TYPE_TAGENDELEMENT",11);   //только закрывающая '>'

define ("NODE_TYPE_PHPELEMENT",7);      //полностью сформированный открывающий PHP-тег
define ("NODE_TYPE_PHPBEGINELEMENT",8); //только открывающая 'php'
define ("NODE_TYPE_PHPENDELEMENT",9);   //только закрывающая 'php'

//define ("NODE_TYPE_ELEMENT",2);
define ("NODE_TYPE_TEXT",3);            //текст
define ("NODE_TYPE_ENDELEMENT",4);      //полностью сформированный закрывающий HTML-тег
define ("NODE_TYPE_COMMENT",5);         //комментарий
define ("NODE_TYPE_DONE",6);

class HtmlParser {

    var $iNodeType;
    var $iNodeName = "";
    var $iNodeValue = "";

    // The following fields should be 
    // considered private:

    var $iHtmlText;
    var $iHtmlTextLength;
    var $iHtmlTextIndex = 0;
    var $iHtmlCurrentChar;
    var $BOE_ARRAY;
    var $B_ARRAY;
    var $BOS_ARRAY;
    var $BO_ARRAY;      
    var $NN_ARRAY;      
    
    /**
     * Constructor.
     * Constructs an HtmlParser instance with
     * the HTML text given.
     */
    function HtmlParser ($aHtmlText) {
        $this->iHtmlText = $aHtmlText;
        $this->iHtmlTextLength = strlen($aHtmlText);
        $this->iNodeAttributes = array();
        $this->setTextIndex (0);

        $this->BOE_ARRAY = array (" ", "\t", "\r", "\n", "=" );
        $this->B_ARRAY = array (" ", "\t", "\r", "\n" );
        $this->BOS_ARRAY = array (" ", "\t", "\r", "\n", "/" );
                $this->BO_ARRAY = array ("<" );
        $this->NN_ARRAY = array (" ", "\t", "\r", "\n", "=","'" );
    }

    /**
     * Method parse.
     * Parses the next node. Returns false only if
     * the end of the HTML text has been reached.
     * Updates values of iNode* fields.
     */
 
    function parse() {
        
        $text = $this->skipToElement();

        if ($text != "") {

            $ppp = strpos($text, ">");
            $mm = substr($text, 0, 1) == ">";
            
            //найдена закрывающая угловая скобка!
            if($ppp || $mm){// 
                        
                //проверим - это закрытие html-тега или php-тега?
                $rest = substr($text, 0, ($ppp+1)); 
                $rr = substr($rest, -2); 
                                
                if($rr=="?>"){// закрытие php-тега
                    $this->iNodeType = NODE_TYPE_PHPENDELEMENT;
                    $this->iNodeName = "phpEndELEMENT";
                    $this->iNodeValue = "$rest";
                }
                elseif($rr=="=>" || $rr=="->"){
                    $this->iNodeType = NODE_TYPE_TEXT;
                    $this->iNodeName = "Text";
                    $this->iNodeValue = $text;
                    return true;                                 
                } 
                elseif($mm==">"){
                    $this->iNodeType = NODE_TYPE_TAGENDELEMENT;
                    $this->iNodeName = "TagEndELEMENT";
                    $this->iNodeValue = "$text";
                    return true;
                }
                else{
                    $this->iNodeType = NODE_TYPE_TAGENDELEMENT;
                    $this->iNodeName = "TagEndELEMENT";
                    $this->iNodeValue = "$rest";
                }

                 $slen = strlen($text); 
                 $this->iHtmlTextIndex = $this->iHtmlTextIndex - $slen; //вернем указатель на начало подстроки

                if($this->iCurrentChar=='<'){$this->moveNext();} //перешагнем через угловую скобку

                $this->skipEndOfTag();
                return true;  
            }
            else{// NODE_TYPE_TEXT
                $this->iNodeType = NODE_TYPE_TEXT;
                $this->iNodeName = "Text";
                $this->iNodeValue = $text;
                return true;
            }

        }//end if ($text != "")
                
        return $this->readTag();
    }
 

    function clearAttributes() {
        $this->iNodeAttributes = array();
    }


    function readTag() {
        
        if ($this->iCurrentChar != "<") {
            $this->iNodeType = NODE_TYPE_DONE;
            return false;
        }
        $this->clearAttributes();
        $this->skipMaxInTag ("<", 1);

        /*****
         * 1. Спарсим ЗАКРЫВАЮЩИЙ ТЕГ узла 
         * в  $name - закрывающий тег узла!
         */
        if ($this->iCurrentChar == '/') {
            $this->moveNext();
            $name = $this->skipToBlanksInTag();
            $name = '</'.$name.'>';
            $this->iNodeType = NODE_TYPE_ENDELEMENT;
            $this->iNodeName = "EndELEMENT";
            $this->iNodeValue = $name;            

            $this->skipEndOfTag();
            return true;
        }
///////////////////////////////////////////////////////////////
        /*****
         * 1. Если  символ, следующий за '<' - плохой? 
         * 
         */
        $chhars = $this->NN_ARRAY;               
        $chs = count($chhars);
        $chch = $this->iCurrentChar;            
        for ($idx = 0; $idx < $chs; $idx++) {
            if ($chch == $chhars[$idx]) {
                $this->moveNext();
                $name = $this->skipToElement();
                $name = '<'.$chch."$name";
                $this->iNodeType = NODE_TYPE_TEXT;
                $this->iNodeName = "Text";
                $this->iNodeValue = $name;  
                return true;
            }
        }                       
///////////////////////////////////////////////////////////////
        $name = $this->skipToBlanksOrSlashInTag(); 

        if (!$this->isValidTagIdentifier ($name)) {//валидация 

            /*****
             * 2. Спарсим КОММЕНТАРИЙ 
             * в  $name - комментарий!
             */
            $comment = false;

            if (strpos($name, "!--") === 0) {

                if (strpos($name, "--", 3) === (strlen($name) - 2)) {
                    $this->iNodeType = NODE_TYPE_COMMENT;
                    $this->iNodeName = "Comment";
                    $this->iNodeValue = "<" . $name . ">";
                    $comment = true;    
                }
                else {
                    $rest = $this->skipToStringInTag ("-->");    
                    if ($rest != "") {
                        $this->iNodeType = NODE_TYPE_COMMENT;
                        $this->iNodeName = "Comment";
                        $this->iNodeValue = "<" . $name . $rest;
                        $comment = true;
                        // Already skipped end of tag
                        return true;
                    }
                }
            }
///////////////////////////////////////////////////////////////

            /*****
             * 3. Спарсим ОТКРЫВАЮЩИЙ ТЕГ узла 
             * в $name - имя открывающего тега!
             */                              
            if (!$comment) {
                //1. 
                if(strpos($name, "?php") === 0){//это ИМЯ '?php' открывающего тега узла!

                    $name = "<" . $name; 

                    $text = $this->skipToInTag($this->BO_ARRAY);
                                        
                    if($this->iCurrentChar =='>'){
                        $text .= ">";
                        $this->moveNext();                                              
                    }
                                        
                    if ($text != "") {
                                        
                        $ppp = strpos($text, ">");
            
                        if($ppp){  

                            $name .= $text;
                                                        
                            $this->iNodeType = NODE_TYPE_PHPELEMENT;
                            $this->iNodeName = "phpELEMENT";
                            $this->iNodeValue = $name;            
                            return true;  

                        }
                        else{ 

                            $name .= $text;
                                                        
                            $this->iNodeType = NODE_TYPE_PHPBEGINELEMENT;
                            $this->iNodeName = "phpBeginELEMENT";
                            $this->iNodeValue = $name;
                            return true;
                        }

                    }

                }
                // 2.
                else{//это ИМЯ '<div ' открывающего тега узла!

                    $name = "<" . $name;
                                        
                    if($this->iCurrentChar=='>'){

                        $name = $name.">";
                        $this->iNodeType = NODE_TYPE_TAGELEMENT;
                        $this->iNodeName = "TagELEMENT";
                        $this->iNodeValue = $name;
                        $this->moveNext();
                        return true;                                        
                    }
                                        
                    $text = $this->skipToElement();

                    if ($text != "") {

                        $ppp = strpos($text, ">");

                        if($ppp){  

                            $slen = strlen($text); 
                            $this->iHtmlTextIndex = $this->iHtmlTextIndex - $slen; 
                                                        
                            if($this->iCurrentChar=='<'){$this->moveNext();} 
                                                        
                            $text = substr($text,0,($ppp+1)); 
                                                
//                            $yu = 0;
                            while ($rr = strpos($text, "=")) {//найдем атрибуты
//                                $yu++; if($yu > 5) break; 
                                                                
                                if($this->iCurrentChar==-1){$this->iCurrentChar="";} 
                                $attrName = $this->skipToBlanksOrEqualsInTag();

                                if ($attrName != "" && $attrName != "/") {
                                                                
                                    $this->skipBlanksInTag();
                                    if ($this->iCurrentChar == "=") {
                                        $this->skipEqualsInTag();
                                        $this->skipBlanksInTag();
                                        $value = $this->readValueInTag();
                
                                        $name .= " ". $attrName . "=\"" . $value . "\"";
                                    }
                                    else {
                                        $name .= " ". $attrName . "=\"" . "" . "\"";
                                    }
                                                                        
                                    if($this->iCurrentChar=='>'){
                                                                         
                                        $name .= '>'; 
                                        $this->iNodeType = NODE_TYPE_TAGBEGINELEMENT;
                                        $this->iNodeName = "TagBeginELEMENT";
                                        $this->iNodeValue = $name;
                                                                                
                                        $this->moveNext();
                                        return true;
                                    } 
                                                                
                                    $ttext = $this->skipToElement();

                                    if(strpos($ttext, "=")){
                         
                                        $sl = strlen($ttext); 
                                        $this->iHtmlTextIndex = $this->iHtmlTextIndex - $sl; 

                                        if($this->iCurrentChar=='<'){$this->moveNext();} 

                                    }
                                    else{
                                        $sll = strlen($ttext); 
                                        $this->iHtmlTextIndex = $this->iHtmlTextIndex - $sll; 

                                        if($this->iCurrentChar=='<'){$this->moveNext();} 

                                        $name .= '>'; 
                                        $this->iNodeType = NODE_TYPE_TAGELEMENT;
                                        $this->iNodeName = "TagELEMENT";
                                        $this->iNodeValue = $name;
                                        return true; 
                                    }
                                }  
                                 
                            }//end while                                                        
 
                            $this->skipEndOfTag();
                           
                            $name .= $text;
                                                        
                            $this->iNodeType = NODE_TYPE_TAGBEGINELEMENT;
                            $this->iNodeName = "TagBeginELEMENT";
                            $this->iNodeValue = $name;
                            return true;  
                        }
                        else{//не найдена '>' 

                            $name .= $text;
                                                        
                            $this->iNodeType = NODE_TYPE_TAGBEGINELEMENT;
                            $this->iNodeName = "TagBeginELEMENT";
                            $this->iNodeValue = $name;
                            return true;
                        }

                    }

                }

            }//end if (!$comment) 

        }
        else {//строка содержит "плохие" символы?
            //эта ветка никогда не выполняется?
            echo(" \r\n Bad simbols in string??? \r\n");  
        }
                
        $this->skipEndOfTag();
        return true;            

    }//end function readTag()
        
    function isValidTagIdentifier ($name) {
                return preg_match ("( /^[A-Za-z0-9_\\-]+$)", $name);
    }
    
    function skipBlanksInTag() {
        return "" != ($this->skipInTag ($this->B_ARRAY));
    }

    function skipToBlanksOrEqualsInTag() {
        return $this->skipToInTag ($this->BOE_ARRAY);
    }

    function skipToBlanksInTag() {
        return $this->skipToInTag ($this->B_ARRAY);
    }

    function skipToBlanksOrSlashInTag() {
        return $this->skipToInTag ($this->BOS_ARRAY);
    }

    function skipEqualsInTag() {
        return $this->skipMaxInTag ("=", 1);
    }

    function readValueInTag() {
        $ch = $this->iCurrentChar;
        $value = "";
        if ($ch == "\"") {
            $this->skipMaxInTag ("\"", 1);
            $value = $this->skipToInTag ("\"");
            $this->skipMaxInTag ("\"", 1);
        }
        else if ($ch == "'") {
            $this->skipMaxInTag ("'", 1);
            $value = $this->skipToInTag ("'");
            $this->skipMaxInTag ("'", 1);
        }                
        else {
            $value = $this->skipToBlanksInTag();
        }
        return $value;
    }

    function setTextIndex ($index) {
        $this->iHtmlTextIndex = $index;
        if ($index >= $this->iHtmlTextLength) {
            $this->iCurrentChar = -1;
        }
        else {
            $this->iCurrentChar = $this->iHtmlText{$index};
        }
    }

    function moveNext() {
        if ($this->iHtmlTextIndex < $this->iHtmlTextLength) {
            $this->setTextIndex ($this->iHtmlTextIndex + 1);
            return true;
        }
        else {
            return false;
        }
    }

    function skipEndOfTag() {
        while (($ch = $this->iCurrentChar) !== -1) {
            if ($ch == ">") {
                $this->moveNext();
                return;
            }
            $this->moveNext();
        }
    }

    function skipInTag ($chars) {
        $sb = "";
        while (($ch = $this->iCurrentChar) !== -1) {
            if ($ch == ">") {
                return $sb;
            } else {
                $match = false;
                for ($idx = 0; $idx < count($chars); $idx++) {
                    if ($ch == $chars[$idx]) {
                        $match = true;
                        break;
                    }
                }
                if (!$match) {
                    return $sb;
                }
                $sb .= $ch;
                $this->moveNext();
            }
        }
        return $sb;
    }

    function skipMaxInTag ($chars, $maxChars) {
        $sb = "";
        $count = 0;
        while (($ch = $this->iCurrentChar) !== -1 && $count++ < $maxChars) {
            if ($ch == ">") {
                return $sb;
            } else {
                $match = false;
                for ($idx = 0; $idx < count($chars); $idx++) {
                    if ($ch == $chars[$idx]) {
                        $match = true;
                        break;
                    }
                }
                if (!$match) {
                    return $sb;
                }
                $sb .= $ch;
                $this->moveNext();
            }
        }
        return $sb;
    }

    function skipToInTag ($chars) {
        $sb = "";
        while (($ch = $this->iCurrentChar) !== -1) {
            $match = $ch == ">";
                        
            if (!$match) {
                for ($idx = 0; $idx < count($chars); $idx++) {
                    if ($ch == $chars[$idx]) {
                        $match = true;
                        break;
                    }
                }
            }
            if ($match) {
                return $sb;
            }
            $sb .= $ch;
            $this->moveNext();
        }
        return $sb;
    }

    function skipToElement() {
        $sb = "";
        while (($ch = $this->iCurrentChar) !== -1) {
            if ($ch == "<") {
                return $sb;
            }
            $sb .= $ch;
            $this->moveNext();
        }
        return $sb;             
    }

    /**
     * Returns text between current position and $needle,
     * inclusive, or "" if not found. The current index is moved to a point
     * after the location of $needle, or not moved at all
     * if nothing is found.
     */
    function skipToStringInTag ($needle) {
        $pos = strpos ($this->iHtmlText, $needle, $this->iHtmlTextIndex);
        if ($pos === false) {
            return "";
        }
        $top = $pos + strlen($needle);
        $retvalue = substr ($this->iHtmlText, $this->iHtmlTextIndex, $top - $this->iHtmlTextIndex);
        $this->setTextIndex ($top);
        return $retvalue;
    }
        
}//end class HTMLParser

function HtmlParser_ForFile ($fileName) { return HtmlParser_ForURL($fileName); }

function HtmlParser_ForURL ($url) {

    $fp = fopen ($url, "r");
    $content = "";
    while (true) {
        $data = fread ($fp, 8192);
        if (strlen($data) == 0) {
            break;
        }
        $content .= $data;
    }
    fclose ($fp);
    return new HtmlParser ($content);
}

function structOfTag($parser){

    $masPrim = array();
    $index = 0; 

    while ($parser->parse()) {
        
        $Arr["struct"] = array(
            "name"=>"", 
            "type"=>"", 
            "value"=>""
        );

        $Arr["struct"]["name"] =  $parser->iNodeName;
        $Arr["struct"]["type"] =  $parser->iNodeType;

        if($parser->iNodeType != NODE_TYPE_DONE ) {
            $Arr["struct"]["value"] = $parser->iNodeValue;
        }

        $masPrim[$index] = $Arr;
        $index++;
    }

    return $masPrim; 
}

?>
